// ZenLib::File_ - file manipulation
// Copyright (C) 2002-2003 Jrme Martinez, Zen@MediaArea.net
//
// This software is provided 'as-is', without any express or implied
// warranty.  In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//    claim that you wrote the original software. If you use this software
//    in a product, an acknowledgment in the product documentation would be
//    appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//    misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// Version 0.0.1
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// 0.1.0.001 (Zen@MediaArea.net, 2003-06-14)
// Warning : will change in future
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//---------------------------------------------------------------------------
#include <ZenLib/File_.h>
#include <ZenLib/Utils.h>
#include <windows.h>
#include <winbase.h>
//---------------------------------------------------------------------------

namespace ZenLib
{

//***************************************************************************
// Gestion de la classe
//***************************************************************************

//---------------------------------------------------------------------------
//Constructeur
File_::File_ ()
{
    End=true;
    Nom=_T("");
}

//---------------------------------------------------------------------------
//Destructeur
File_::~File_ ()
{
}                   

//***************************************************************************
// Divers
//***************************************************************************

//---------------------------------------------------------------------------
//End
bool File_::Eof()
{
    return End;
}

int64u File_::Size_Get()
{
  HANDLE m_hFile=CreateFile (Nom.c_str(), 0, 0, 0, 0, 0, 0);
  if ((int)m_hFile==-1)
    return 0;
  DWORD dwHighLength;
  DWORD dwLowLength = GetFileSize(m_hFile, &dwHighLength);
  return int32u_int64u(dwHighLength, dwLowLength);
}

int64u File_::Size_Get(const Ztring &Fichier)
{
  HANDLE m_hFile=CreateFile (Fichier.c_str(), 0, 0, 0, OPEN_EXISTING	, 0, 0);
  if ((int)m_hFile==-1)
    return 0;
  DWORD dwHighLength;
  DWORD dwLowLength = GetFileSize(m_hFile, &dwHighLength);
  return int32u_int64u(dwHighLength, dwLowLength);
}


//***************************************************************************
// Utils
//***************************************************************************

//---------------------------------------------------------------------------
//
ZtringList File_::Chercher(Ztring Liste)
{
    ZtringList Retour;

    LPWIN32_FIND_DATA Infos=new WIN32_FIND_DATA;
    HANDLE Handle=FindFirstFile(Liste.c_str(), Infos);
    BOOL Ok=true;

    while (Handle!=INVALID_HANDLE_VALUE && Ok)
    {
        Retour.push_back(Infos->cFileName);
        Ok = FindNextFile(Handle, Infos);
    }
    FindClose(Handle);
    delete Infos;
    return Retour;
}

//---------------------------------------------------------------------------
//
int File_::Exist(Ztring File)
{
/*ToDo A voir sous Visual C++
    struct ffblk ffblk;
    int done;
    done = findfirst(File.Char(), &ffblk, 0);
    return !done;
*/
	return 1;
}

//---------------------------------------------------------------------------
//
int File_::Copy(Ztring &Existing, Ztring &New, int FailExist)
{
    return CopyFile(Existing.c_str(), New.c_str(), FailExist);
}

//---------------------------------------------------------------------------
//
int File_::Supprimer(Ztring &Fichier)
{
    return DeleteFile(Fichier.c_str());
}

} //Namespace
