// ZenLib::ZtringListList - vector<vector<std::string>> is better
// Copyright (C) 2002-2003 Jrme Martinez, Zen@MediaArea.net
//
// This software is provided 'as-is', without any express or implied
// warranty.  In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//    claim that you wrote the original software. If you use this software
//    in a product, an acknowledgment in the product documentation would be
//    appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//    misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.
//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// Version 0.1.0
//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// ToDo
// Rajouter les tests d'integrite
// () et [] const ne se pas bons
//
//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//---------------------------------------------------------------------------
#include <ZenLib/ZtringListList.h>
#include <tchar.h>
//---------------------------------------------------------------------------


namespace ZenLib
{
static ZtringList Chaine_Tableau2_Bidon1;
static Ztring Chaine_Tableau2_Bidon;
using std::vector; //Visual C++ 6 patch

//***************************************************************************
// Gestion de la classe
//***************************************************************************

//---------------------------------------------------------------------------
// Constructeurs
void ZtringListList::ZtringListList_Common (int Taille_Max2, int Taille_Max1, const Ztring &Separateur1, const Ztring &Separateur2, const Char* Source)
{
//    size_=0;

    //Gestion n
    reserve(Taille_Max2);

    //Gestion separateur
    Separateur[0]=Separateur1;
    Separateur[1]=Separateur2;

    //Gestion Source
    if (Source!=_T(""))
        Ecrire(Source);
}

ZtringListList::ZtringListList(int Taille_Max2, int Taille_Max1, const Ztring &Separateur1, const Ztring &Separateur2, const Ztring &Source)
{
    ZtringListList_Common(Taille_Max2, Taille_Max1, Separateur1, Separateur2, Source.c_str());
}

ZtringListList::ZtringListList(const ZtringListList &Source)
{
    ZtringListList_Common(0, Source.size(), Source.Separateur[0], Source.Separateur[1], (Source.Lire()).c_str());
}

ZtringListList::ZtringListList(const Ztring &Source)
{
    ZtringListList_Common(0, 0, _T("\r\n"), _T(";"), Source.c_str());
}

ZtringListList::ZtringListList(const Char *Source)
{
    ZtringListList_Common(0, 0, _T("\r\n"), _T(";"), Source);
}

//---------------------------------------------------------------------------
// Destructeurs
ZtringListList::~ZtringListList()
{
}

//***************************************************************************
// Operateurs
//***************************************************************************

//---------------------------------------------------------------------------
// Operateur =
ZtringListList &ZtringListList::operator = (const ZtringListList &Source)
{
    clear();

    Ztring C0=Separateur[0];
    Ztring C1=Separateur[1];

    ZtringListList_Common(0, Source.size(), Source.Separateur[0], Source.Separateur[1], (Source.Lire()).c_str());

    Separateur[0]=C0;
    Separateur[1]=C1;

    return *this;
}

//---------------------------------------------------------------------------
//Operateur ==
bool ZtringListList::operator == (const ZtringListList &Source) const
{
    return (Lire()==Source.Lire());
}

//---------------------------------------------------------------------------
//Operateur !=
bool ZtringListList::operator != (const ZtringListList &Source) const
{
    return (!(Lire()==Source.Lire()));
}

//---------------------------------------------------------------------------
// Operateur ()
ZtringList &ZtringListList::operator () (size_t Pos0)
{
    //Test integrite
    if (Pos0>=size())
        Ecrire(_T(""), Pos0);

    return operator [] (Pos0);
}

/*
ZtringList &ZtringListList::operator () (size_t Pos0) const
{
    //Test integrite
    if (Pos0>=size())
        Ecrire("", Pos0);

    return operator [] (Pos0);
}
*/

Ztring &ZtringListList::operator () (size_t Pos0, size_t Pos1)
{
    if (Pos0>=size())
        Ecrire(_T(""), Pos0);

    if (Pos1>=operator [] (Pos0).size())
        operator [] (Pos0).Ecrire(_T(""), Pos1);

    return operator [] (Pos0).operator () (Pos1);
}


Ztring &ZtringListList::operator () (const Ztring &Pos0, size_t Pos1)
{
    size_t Pos=Rechercher(Pos0);
    if (Pos==-1)
    {
        //Chaine_Tableau2_Bidon="";
        //return Chaine_Tableau2_Bidon;
        Pos=size();
        Ecrire (Pos0, Pos, 0);
    }

    return operator() (Pos, Pos1);
}

Ztring &ZtringListList::operator () (const Ztring &Pos0, size_t Pos0_1, size_t Pos1)
{
    int Pos=Rechercher(Pos0, Pos0_1);
    if (Pos==-1)
    {
        //Chaine_Tableau2_Bidon="";
        //return Chaine_Tableau2_Bidon;
        //Ecrire (Pos0, size(), Pos0_1);
        Pos=size();
    }

    return operator() (Pos, Pos1);
}

/*
CChaine &ZtringListList::operator () (int Pos0, int Pos1) const
{
    //Test integrite
    if (Pos0<0)
    {
        Chaine_Tableau2_Bidon="";
        return Chaine_Tableau2_Bidon;
    }
    if (Pos0>=Taille_Get(0))
        Pos0=Taille_Get(0)-1;

    //Gestion Tableau vide ou chaine vide
    if (Taille_Get(0)==0 || !Chaine[Pos0])
        return Chaine_Tableau2_Bidon1(Pos1) ;

    return (*Chaine[Pos0])(Pos1);
}
*/
/*
//---------------------------------------------------------------------------
// Operateur ()
CChaine_Tableau1 &ZtringListList::operator [] (int Pos0)
{
    Nettoyer();
    //Test integrite
    if (Pos0<0)
        Pos0=0;

    while (Pos0>=Taille_Max[0])
        Taille_Max_Set(Taille_Max[0]*2);

    if (!Chaine[Pos0])
    {
        Chaine[Pos0]=new CChaine_Tableau1(Taille_Max[1]);
        Chaine[Pos0]->Separateur_Set(Separateur[1]);
    }
    if (Pos0>=Taille[0])
        Taille[0]=Pos0+1;

    return *Chaine[Pos0];
}

CChaine_Tableau1 &ZtringListList::operator [] (int Pos0) const
{
    //Test integrite
    if (Pos0<0)
        Pos0=0;
    if (Pos0>=Taille_Get(0))
        Pos0=Taille_Get(0)-1;

    //Gestion Tableau vide ou chaine vide
    if (Taille_Get(0)==0 || !Chaine[Pos0])
        return Chaine_Tableau2_Bidon1 ;

    return *Chaine[Pos0];
}
*/

//***************************************************************************
// Edition
//***************************************************************************

//---------------------------------------------------------------------------
// Lecture
Ztring ZtringListList::Lire () const
{
    Ztring Retour;
    for (size_type Pos0=0; Pos0<size(); Pos0++)
    {
        Retour+=Lire(Pos0);
        Retour+=Separateur[0];
    }
    if (Retour.size()>Separateur[0].size())
        Retour[Retour.size()-Separateur[0].size()]=_T('\0');

    return Retour;
}

Ztring ZtringListList::Lire (size_t Pos0) const
{
    if (Pos0>=size())
        return _T("");

    return operator [] (Pos0).Lire();
}

Ztring ZtringListList::Lire (size_t Pos0, size_t Pos1) const
{
    if (Pos0>=size())
        return _T("");

    return operator [] (Pos0).Lire(Pos1);
}

Ztring ZtringListList::Lire (const Ztring &Pos0, size_t Pos1) const //Lecture d'un champs en position 0
{
    size_t Pos=Rechercher(Pos0);
    if (Pos==-1)
        return _T("");
    return Lire(Pos, Pos1);
}

Ztring ZtringListList::Lire (const Ztring &Pos0, Ztring Default, size_t Pos1) const //Lecture d'un champs en position 0 avec une option par defaut
{
    size_t Pos=Rechercher(Pos0);
    if (Pos==-1)
        return Default;
    return Lire(Pos, Pos1);
}

/*
Ztring ZtringListList::Lire (const CChaine &Pos0, size_t Pos0_1, size_t Pos1) const
{
    int Pos=Rechercher(Pos0, Pos0_1);
    if (Pos<0)
        return "";
    return Lire(Pos, Pos1);
}

*/
Ztring ZtringListList::Lire1 (size_t Pos1) const
{
    Ztring Retour;
    for (size_type Pos=0; Pos<size(); Pos++)
        Retour+=operator [] (Pos).Lire(Pos1)+Separateur[0];

    return Retour.substr(0, Retour.size()-2);
}

//---------------------------------------------------------------------------
// Ecriture
int ZtringListList::Ecrire(const Ztring &AEcrire)
{
    clear();
    if (!&AEcrire || !AEcrire.size())
        return 1;

    size_t Pos0=0;
    size_t PosC=0;
    bool Fini=false;
    Ztring C1;

    do
    {
        C1=AEcrire.SubString(_T(""), Separateur[0], PosC, Ztring_AddLastItem);
        Ecrire(C1, Pos0);
        Pos0++;
        PosC+=C1.size()+Separateur[0].size();
        if (PosC>=AEcrire.size())
            Fini=true;
    }
    while (!Fini);

    return 1;
}

int ZtringListList::Ecrire(const Char *AEcrire, size_t Pos0)
{
    return Ecrire(Ztring(AEcrire), Pos0);
}

int ZtringListList::Ecrire(const Ztring &AEcrire, size_t Pos0)
{
    if (!capacity())
        reserve(1);

    //Reservation de ressources
    while (Pos0>=capacity())
        reserve(capacity()*2);

    //ecriture
    if (Pos0>=size())
    {
        while (Pos0>size())
            push_back (_T(""));
        push_back(AEcrire);
    }
    else
        operator [] (Pos0)=AEcrire;

    return 1;
}


int ZtringListList::Ecrire(const ZtringList &AEcrire, size_t Pos0)
{
    return Ecrire(AEcrire.Lire(), Pos0);
}

int ZtringListList::Ecrire(const Ztring &AEcrire, size_t Pos0, size_t Pos1)
{
    if (Pos0>=size())
        //Pas cr
        Ecrire(_T(""), Pos0);

    operator [] (Pos0).Ecrire(AEcrire, Pos1);
    return 1;
}

void ZtringListList::push_back (Char* ToAdd)
{
    ZtringList Z1;
    Z1.Separateur_Set(Separateur[1]);
    Z1=ToAdd;
    vector<ZtringList>::push_back(Z1); //Visual C++ 6 patch, should be std::vector
}

void ZtringListList::push_back (const ZtringList &ToAdd)
{
    vector<ZtringList>::push_back(ToAdd); //Visual C++ 6 patch, should be std::vector
    operator () (size()-1).Separateur_Set(Separateur[1]);
}

/*
int ZtringListList::Ecrire(const CChaine &AEcrire, const CChaine &Pos0, int Pos1)
{
    return Ecrire (AEcrire, Pos0, 0, Pos1);

}

int ZtringListList::Ecrire(const CChaine &AEcrire, const CChaine &Pos0, int Pos0_1, int Pos1)
{
    int Pos=Rechercher(Pos0, Pos0_1);
    if (Pos<0)
        return Pos;
    return Ecrire(AEcrire, Pos, Pos1);
}

int ZtringListList::EcrireEx(const CChaine &AEcrire, int Pos0, int Pos1)
{
    if (AEcrire=="")
        return 1; //Pas de changements a faire
    else
        return Ecrire (AEcrire, Pos0, Pos1);
}

//---------------------------------------------------------------------------
// Ajout
int ZtringListList::Ajouter (const CChaine_Tableau1 &AAjouter)
{
    //if (AAjouter.Lire()=="")
    //    return -11;
    Nettoyer();

    if (Taille[0]>=Taille_Max[0])
        Taille_Max_Set(Taille_Max[0]*2);

    if (Ecrire(AAjouter, Taille[0])<0)
        return -1;

    return Taille[0]-1;
}

//---------------------------------------------------------------------------
// Insertion
int ZtringListList::Inserer (const CChaine_Tableau1 &AInserer, int Pos0)
{
    //Test integrite
    if (Taille_Get(0)>=Taille_Max[0])
        Taille_Max_Set(Taille_Max[0]*2);
    Nettoyer();
    while (Pos0>=Taille_Max[0])
        Taille_Max_Set(Taille_Max[0]*2);

    //Decalage
    int Pos=Taille[0];
    while (Pos>Pos0)
    {
        Chaine[Pos]=Chaine[Pos-1];
        Pos--;
    }
    Chaine[Pos]=NULL;
    
    return Ecrire(AInserer, Pos0);
}

int ZtringListList::Inserer1 (const CChaine &AInserer, int Pos1)
{
    Nettoyer();
    for (int Pos0=0; Pos0<Taille[0]; Pos0++)
        if (Chaine[Pos0])
            Chaine[Pos0]->Inserer(AInserer, Pos1);

    return 1;
}

//---------------------------------------------------------------------------
// Permutation
int ZtringListList::Permuter (int Pos0_A, int Pos0_B)
{
    //Test integrite
    int Pos_Max;
    if (Pos0_A>Pos0_B)
        Pos_Max=Pos0_A;
    else
        Pos_Max=Pos0_B;
    while (Pos_Max>=Taille_Max[0])
        Taille_Max_Set(Taille_Max[0]*2);
    Nettoyer();

    CChaine_Tableau1* C1=Chaine[Pos0_A];
    Chaine[Pos0_A]=Chaine[Pos0_B];
    Chaine[Pos0_B]=C1;

    if (Pos_Max>=Taille[0])
        Taille[0]=Pos_Max+1;

    return 1;
}

int ZtringListList::Permuter1 (int Pos1_A, int Pos1_B)
{
    if (Pos1_A<0)
        return -1;
    if (Pos1_B<0)
        return -1;
    Nettoyer();

    //Decalage
    int Pos0=0;
    CChaine C1;
    while (Pos0<Taille_Max[0] && Chaine && Chaine[Pos0])
    {
        //pour chaque ligne
        C1=Chaine[Pos0]->Lire(Pos1_A);
        Chaine[Pos0]->Ecrire(Chaine[Pos0]->Lire(Pos1_B), Pos1_A);
        Chaine[Pos0]->Ecrire(C1, Pos1_B);
        Pos0++;
    }
    return 1;
}

//---------------------------------------------------------------------------
// Suppression
int ZtringListList::Supprimer ()
{
    if (!Chaine)
        return 1;
    Nettoyer();

    for (int Pos0=0; Pos0<Taille[0]; Pos0++)
    {
        delete Chaine[Pos0];
        Chaine[Pos0]=NULL;
    }
    Taille[0]=0;
    
    return 1;
}

int ZtringListList::Supprimer (int Pos0)
{
    if (Pos0<0 || Pos0>=Taille_Max[0])
        return -1;
    Nettoyer();
    if (Taille[0]==0)
        return 2;

    delete Chaine[Pos0];

    //Decalage
    int Pos=Pos0;
    while (Pos<Taille_Max[0]-1)
    {
        Chaine[Pos]=Chaine[Pos+1];
        Pos++;
    }
    Chaine[Pos]=NULL;
    Taille[0]--;

    return 1;
}

int ZtringListList::Supprimer (const CChaine &ARechercher, int Pos1, const CChaine &Comparaison)
{
    Nettoyer();
    int Pos0=0;
    do
    {
        Pos0=Rechercher(ARechercher, Pos1, Pos0, Comparaison);
        Supprimer(Pos0);
    }
    while (Pos0>=0);
    return 1;
}

int ZtringListList::Supprimer1 (int Pos1)
{
    if (Pos1<0)// || Pos1>=Taille_Max[1])
        return -1;
    Nettoyer();

    //Decalage
    for (int Pos0=0; Pos0<Taille[0]; Pos0++)
    {
        //pour chaque ligne
        if (Chaine[Pos0])
            Chaine[Pos0]->Supprimer(Pos1);
    }
    return 1;
}

//---------------------------------------------------------------------------
// Tri
int ZtringListList::Trier (int Pos1, int Options)
{
    Nettoyer();
    int Pos0=1;
    while (Chaine && Chaine[Pos0] && Pos0<Taille[0])
    {
        if (Chaine[Pos0]->Lire(Pos1)<Chaine[Pos0-1]->Lire(Pos1))
        {
            //Invers
            Permuter(Pos0, Pos0-1);
            Pos0=0;
        }
        Pos0++;
    }
    return 1;
}

*/
//---------------------------------------------------------------------------
// Recherche d'une position
int ZtringListList::Rechercher (const Ztring &ARechercher, size_t Pos1, size_t Pos0Debut, const Ztring &Comparaison, int Options) const
{
    if (Pos0Debut>=size())
        return -1;
    size_t Pos0=Pos0Debut;

    while (Pos0<size() && (
                   Comparaison==_T("==")   && operator [] (Pos0).Lire(Pos1)!=ARechercher
                || Comparaison==_T("COMP") && _tcsicmp(operator [] (Pos0).Lire(Pos1).c_str(), ARechercher.c_str())!=0
                || Comparaison==_T("IN")   && operator [] (Pos0).Lire(Pos1).find(ARechercher)==-1
                || Comparaison==_T("<")    && operator [] (Pos0).Lire(Pos1).Convert_int32s()>=ARechercher.Convert_int32s()
                || Comparaison==_T("<=")   && operator [] (Pos0).Lire(Pos1).Convert_int32s()>ARechercher.Convert_int32s()
                || Comparaison==_T(">=")   && operator [] (Pos0).Lire(Pos1).Convert_int32s()<ARechercher.Convert_int32s()
                || Comparaison==_T(">")    && operator [] (Pos0).Lire(Pos1).Convert_int32s()<=ARechercher.Convert_int32s()
                || Comparaison==_T("<>")   && operator [] (Pos0).Lire(Pos1)==ARechercher
                || Comparaison==_T("!=")   && operator [] (Pos0).Lire(Pos1)==ARechercher
                ))
    {
        Pos0++;
    }
    if (Pos0>=size())
        return -1;
    return Pos0;
}

//---------------------------------------------------------------------------
// Recherche de la valeur a une position a rechercher
Ztring ZtringListList::RechercherValeur (const Ztring &ARechercher, size_t Pos1Valeur, size_t Pos1, size_t Pos0Debut, const Ztring &Comparaison, int Options) const
{
    size_t Pos0=Rechercher(ARechercher, Pos1, Pos0Debut, Comparaison);
    if (Pos0==-1)
        return _T("");
    return Lire(Pos0, Pos1Valeur);
}

/*
//---------------------------------------------------------------------------
// Remplacement
int ZtringListList::Remplacer (const CChaine &ARechercher, const CChaine &ARemplacer, int Pos1, const CChaine &Comparaison, int Options)
{
    Nettoyer();
    int Pos0=-1;
    do
    {
        Pos0=Rechercher(ARechercher, Pos1, Pos0+1, Comparaison);
        if (Pos0>=0)
        {
            CChaine C1=Chaine[Pos0]->Lire(Pos1);
            C1.Remplacer(ARechercher, ARemplacer);
            Chaine[Pos0]->Ecrire(C1, Pos1);
            //Chaine[Pos0]->Ecrire(Chaine[Pos0]->Lire(Pos1).Remplacer(ARechercher, ARemplacer), Pos1);
        }
    }
    while (Pos0>=0);
    return 1;
}

//***************************************************************************
// Edition
//***************************************************************************

//---------------------------------------------------------------------------
// Recuperation de la taille
int ZtringListList::Taille_Get (int Rang) const
{
    //Test integrite
    if (Rang<0 || Rang>1)
        return -1;

    int Pos0=Taille[0]-1;
    while (Pos0>=0 && (!Chaine[Pos0] || !Chaine[Pos0]->Taille_Get()))
        Pos0--;
    return Pos0+1;

}

//---------------------------------------------------------------------------
// Modification manuelle de la taille du tableau
int ZtringListList::Taille_Max_Set (int NouvelleTaille, int Taille_Max_Nouveau1)
{
    if (NouvelleTaille<0)
        return -1;

    if (NouvelleTaille==0)
        NouvelleTaille=1;

    if (NouvelleTaille==Taille_Max[0])
        return 1;

    //Init nouvelle chaine
    int TailleMax;
    if (NouvelleTaille<Taille_Max[0])
        TailleMax=NouvelleTaille;
    else
        TailleMax=Taille_Max[0];
    Taille_Max[0]=NouvelleTaille;
    CChaine_Tableau1** C1=new CChaine_Tableau1*[Taille_Max[0]];

    //Transfert
    for (int I1=0; I1<TailleMax; I1++)
        C1[I1]=Chaine[I1];
    for (int I2=TailleMax; I2<Taille_Max[0]; I2++)
        C1[I2]=NULL;
    delete[] Chaine;
    
    //Suppression ancien
    Chaine=C1;

    return 1;
}

*/
//---------------------------------------------------------------------------
// Modificateur du separateur
int ZtringListList::Separateur_Set (const Ztring &NouveauSeparateur0, const Ztring &NouveauSeparateur1)
{
    Separateur[0]=NouveauSeparateur0;
    Separateur[1]=NouveauSeparateur1;
    for (size_type Pos0=0; Pos0<size(); Pos0++)
        operator () (Pos0).Separateur_Set(Separateur[1]);
    return 1;
}

//---------------------------------------------------------------------------
// On remplace car pb, ca marche pas bien!!! :(((
//size_t ZtringListList::size () const
//{
//    return size_;
//}

//---------------------------------------------------------------------------
// Partie d'une tableau
ZtringListList ZtringListList::SousTableau (const Ztring &ARechercher, int Pos1, int Pos0Debut, const Ztring &Comparaison, int Options) const
{
    ZtringListList Retour;
    int Pos0=-1;
    do
    {
        Pos0=Rechercher(ARechercher, Pos1, Pos0+1, Comparaison);
        Retour.push_back(Lire(Pos0));
    }
    while (Pos0>=0);
    return Retour;
}

/*
//---------------------------------------------------------------------------
// Nettoyage
int ZtringListList::Nettoyer ()
{
    if (!Chaine || Taille[0]==0)
        return 1;

    int Pos0=Taille[0]-1;
    while (Pos0>=0 && (!Chaine[Pos0] || !Chaine[Pos0]->Taille_Get()))
    {
        delete Chaine[Pos0];
        Chaine[Pos0]=NULL;
        Taille[0]--;
        Pos0--;
    }
    return 1;
}
*/

} //namespace








